#include <iostream.h>
#include<time.h>
#include<math.h>
#include<sys/types.h>
#include<stdlib.h>
#include <fstream.h>

#include "interface_classes.h"
#include "sdm.h"
#include "target_function.h"
#include "my_target.h"

double triangularSimilarity(const State& s1, const State& s2, double* threshold);

int main(int argc, char* argv[]){

//seed randon number generator
  time_t stime;
  time(&stime);
  struct tm* currentTime;
  currentTime=gmtime(&stime);
  unsigned seed;
  seed=(currentTime->tm_hour+1)*currentTime->tm_min*currentTime->tm_sec;
  srand(seed);

  sdmParameters sdmP;
  sdmP.processCommandLine(argc,argv);
  if (strncmp(argv[1],"?",1)==0) exit(EXIT_SUCCESS);
  


  State::dimensionality=2;
  Approximator* mySDM = new SDM(sdmP, &triangularSimilarity);
  mySDM->setLearningParameters(argc, argv);
  

  int DataSetSize=1000;
  int TrainingSetSize=800;
  int TestSetSize=200;

  MyTarget* myFunction = new MyTarget(DataSetSize);

  myFunction->loadDataSet(0, NULL);
  myFunction->formTrainingAndTestSets(TrainingSetSize, TestSetSize);


  int i,j;
  int LearningIterations=100000;
  State input;
  double target;
  double prediction;
  double testError;

  for (i=0; i<LearningIterations+1; i++){

    if ( (i % 1000) == 0) {
      testError=0;
      for (j=0; j< TestSetSize; j++){

	myFunction->getTestSample(input, target, j);
        mySDM->predict(input,prediction);
	testError += (target-prediction)*(target-prediction);
      }
      cout << "Iteration " << i << " Error=" << sqrt(testError) << endl; 
    }

    myFunction->getTrainingSample(input, target);
    mySDM->learn(input, target);
  }
    

  char* par[1];
  par[0] = new char[8];
  strcpy(par[0],"test.sdm");
  mySDM->saveArchitectureParameters(1,par);
  return 0;
}
